import _extends from "@babel/runtime/helpers/esm/extends";
import { jsx as _jsx } from "react/jsx-runtime";
import { useState } from 'react';
import CollapsibleBasic from '@s-ui/react-collapsible-basic';

function CollapsibleAccordion(_ref) {
  var _ref$preserveState = _ref.preserveState,
      preserveState = _ref$preserveState === void 0 ? false : _ref$preserveState,
      _ref$onItemChange = _ref.onItemChange,
      onItemChange = _ref$onItemChange === void 0 ? function (collapsed, id) {} : _ref$onItemChange,
      items = _ref.items,
      icon = _ref.icon;

  var _useState = useState(null),
      openIndex = _useState[0],
      setOpenIndex = _useState[1];

  var handleClick = function handleClick(id) {
    return function (collapsed) {
      return !preserveState && collapseItems(collapsed, id);
    };
  };

  var collapseItems = function collapseItems(collapsed, id) {
    var newOpenIndex = id === openIndex ? null : id;
    setOpenIndex(newOpenIndex);
    onItemChange(collapsed, id);
  };

  return /*#__PURE__*/_jsx("div", {
    children: items.map(function (item, index) {
      return /*#__PURE__*/_jsx(CollapsibleBasic, _extends({}, item, {
        collapsed: openIndex !== index,
        handleClick: handleClick(index),
        icon: icon,
        children: item.content
      }), index);
    })
  });
}

CollapsibleAccordion.displayName = 'CollapsibleAccordion';
export default CollapsibleAccordion;